/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/rel-192-xr-w32-bld/build/widget/public/nsITaskbarPreview.idl
 */

package org.mozilla.interfaces;

/**
 * nsITaskbarPreview
 *
 * Common interface for both window and tab taskbar previews. This interface
 * cannot be instantiated directly.
 *
 */
public interface nsITaskbarPreview extends nsISupports {

  String NS_ITASKBARPREVIEW_IID =
    "{cbfdf766-d002-403b-a3d9-b091c9ad465b}";

  /**
   * The controller for this preview. A controller is required to provide
   * the behavior and appearance of the taskbar previews. It is responsible for
   * determining the size and contents of the preview, which buttons are
   * displayed and how the application responds to user actions on the preview.
   *
   * Neither preview makes full use of the controller. See the documentation
   * for nsITaskbarWindowPreview and nsITaskbarTabPreview for details on which
   * controller methods are used.
   *
   * The controller is not allowed to be null.
   *
   * @see nsITaskbarPreviewController
   */
  nsITaskbarPreviewController getController();

  /**
   * The controller for this preview. A controller is required to provide
   * the behavior and appearance of the taskbar previews. It is responsible for
   * determining the size and contents of the preview, which buttons are
   * displayed and how the application responds to user actions on the preview.
   *
   * Neither preview makes full use of the controller. See the documentation
   * for nsITaskbarWindowPreview and nsITaskbarTabPreview for details on which
   * controller methods are used.
   *
   * The controller is not allowed to be null.
   *
   * @see nsITaskbarPreviewController
   */
  void setController(nsITaskbarPreviewController aController);

  /**
   * The tooltip displayed above the preview when the user hovers over it
   *
   * Default: an empty string
   */
  String getTooltip();

  /**
   * The tooltip displayed above the preview when the user hovers over it
   *
   * Default: an empty string
   */
  void setTooltip(String aTooltip);

  /**
   * Whether or not the preview is visible.
   *
   * Changing this option is expensive for tab previews since toggling this
   * option will destroy/create the proxy window and its registration with the
   * taskbar. If any step of that fails, an exception will be thrown.
   *
   * For window previews, this operation is very cheap.
   *
   * Default: false
   */
  boolean getVisible();

  /**
   * Whether or not the preview is visible.
   *
   * Changing this option is expensive for tab previews since toggling this
   * option will destroy/create the proxy window and its registration with the
   * taskbar. If any step of that fails, an exception will be thrown.
   *
   * For window previews, this operation is very cheap.
   *
   * Default: false
   */
  void setVisible(boolean aVisible);

  /**
   * Gets/sets whether or not the preview is marked active (selected) in the
   * taskbar.
   */
  boolean getActive();

  /**
   * Gets/sets whether or not the preview is marked active (selected) in the
   * taskbar.
   */
  void setActive(boolean aActive);

  /**
   * Invalidates the taskbar's cached image of this preview, forcing a redraw
   * if necessary
   */
  void invalidate();

}